//#include "util.h"
#include "korean.h"
#include <string.h>

#ifdef _MSC_VER
#define strncasecmp strnicmp
#endif

#if USE_555_FORMAT
// Assume the 16 bit graphics data is in 5-5-5 format
#define RGB_TO_16(r,g,b)	(((((r)>>3)&0x1F) << 10) | ((((g)>>3)&0x1F) << 5) | (((b)>>3)&0x1F))
#define RED_FROM_16(x)		((((x)>>10)&0x1F) << 3)
#define GREEN_FROM_16(x)	((((x)>>5)&0x1F) << 3)
#define BLUE_FROM_16(x)		(((x)&0x1F) << 3)

#elif defined(__GP32__) //ph0x
// GP32 format 5-5-5-1 (first bit means intensity)
#define RGB_TO_16(r,g,b)	(((((r)>>3)&0x1F) << 11) | ((((g)>>3)&0x1F) << 6) | (((b)>>3)&0x1F)<<1)
#define RED_FROM_16(x)		((((x)>>11)&0x1F) << 3)
#define GREEN_FROM_16(x)	((((x)>>6) &0x1F) << 3)
#define BLUE_FROM_16(x)		((((x)>>1) &0x1F) << 3)

#else
// Assume the 16 bit graphics data is in 5-6-5 format
#define RGB_TO_16(r,g,b)	(((((r)>>3)&0x1F) << 11) | ((((g)>>2)&0x3F) << 5) | (((b)>>3)&0x1F))
#define RED_FROM_16(x)		((((x)>>11)&0x1F) << 3)
#define GREEN_FROM_16(x)	((((x)>>5)&0x3F) << 2)
#define BLUE_FROM_16(x)		(((x)&0x1F) << 3)
#endif

enum FONT_PATTERN {	NORMAL_PATTERN = 0,	INC16_PATTERN,	DEC16_PATTERN,
					INC8_PATTERN,	DEC8_PATTERN,	DECINC_PATTERN,	INCDEC_PATTERN, };
enum FONT_FILE_TYPE{HANGUL_FNT,	ENGLISH_FNT,};

/*char HANKSB[2350][32];*/
char HANKSB[2350][30]; // 16 x 15
char HANKSS[2350][18]; //  9 x 10
char EFB[256][16]; // 8 x 16
char EFS[256][8]; //  8 x 8

int ENGLISH_WIDTH = 0;
int HANGUL_WIDTH  = 0;
int SPACE_WIDTH   = 0;

int kFontHeight=0; // ѱ Ʈ 
int eFontHeight=0; //  Ʈ 

char *pPattern;
char pattNormal[16]   ={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};


FILE *korOutput;

int xxi;				// ֿܼ
char strBuf[8000][256];	// ֿܼ  ӽ (޸ ... 2mb...)

char gameFN[16];
char Kostr[16];

char k_parse_buffer[1024]; // ޸𸮸  ƴ϶ ...

STRKOR KorStrings[48];
STRKOR kor_str_desc[48];
STRKORSMUSH kor_str_smush[48];

typedef struct {
	char *data;
	uint16 attr;
}STRKORBUFFER;

STRKORBUFFER *korBuffer;	// ѱ    
//char **korBuffer;	// ѱ    
int korMax;			//    

int desc_num;		//description   ȣ.

KOR_Color *kpalette;

bool _kor_font;		// ū Ʈ ?
bool _kor_mode;		// ѱ ڸ ?
bool _not_eng;		//  ڸ ?
bool isCMI;			// COMIΰ?

void add2stack(char *buf,uint16 xpos,uint16 ypos,short delay,uint8 pal)
{
	int num;
	for(num=0;num<MAX_KOR-1;num++)
		if(!(KorStrings[num].buffer[0] && 0))
			break;
	KorStrings[num].xpos=xpos;
	KorStrings[num].ypos=ypos;
	KorStrings[num].delay=delay;
	KorStrings[num].color=pal;
	strcpy(KorStrings[num].buffer,buf);
	KorStrings[num].remainflag=1;
	KorStrings[num].remainstart=1;
	KorStrings[num].remainend=0;
	//printf("Init string as #%d x %d y %d delay %d color %d\n",num,xpos,ypos,delay,pal);
}
void add2stack_desc(char *buf,uint16 xpos,uint16 ypos,short delay,uint8 pal)
{
	int num;
	//for(num=0;num<MAX_KOR-1;num++)
	//for(num=0;num<3;num++)
		//if(!(kor_str_desc[num].buffer[0] && (kor_str_desc[num].delay)))
		//if(!(kor_str_desc[num].remainflag))
			//break;
	//desc_num = 1 - desc_num;
	desc_num = 0;
	num = desc_num;
	strcpy(kor_str_desc[num].buffer,buf);
	kor_str_desc[num].xpos=xpos;
	kor_str_desc[num].ypos=ypos;
	kor_str_desc[num].delay=delay;
	kor_str_desc[num].color=pal;
	kor_str_desc[num].remainflag=1;
	kor_str_desc[num].remainstart=1;
	kor_str_desc[num].remainend=0;
	//printf("Init desc as #%d x %d y %d delay %d color %d\n",num,xpos,ypos,delay,pal);//*/
}
void add2stack_smush(char *buf,long xpos,long ypos,uint8 col,int tmp)
{
	int num;
	for(num=0;num<MAX_KOR-1;num++)
		if(!(kor_str_smush[num].buffer[0]&&kor_str_smush[num].remain))
			break;
	kor_str_smush[num].xpos=MAX(xpos,2);
	//kor_str_smush[num].xright=320-xpos;
	kor_str_smush[num].ypos=MAX(ypos,2);
	kor_str_smush[num].color=col;
	kor_str_smush[num].remain=1;
	strcpy(kor_str_smush[num].buffer,buf);
	//printf("SMUSH #%d %x flag %d\n%s\n%s\n",
			//num, &kor_str_smush[num].buffer[0], tmp, buf, kor_str_smush[num].buffer);
	//printf("SMUSH #%d %s x %d y %d c %d flag %d\n",
			//num, kor_str_smush[num].buffer, kor_str_smush[num].xpos,
			//kor_str_smush[num].ypos, kor_str_smush[num].color, tmp);
}

void KoreanCharset(char *buffer)
{
}

void LoadKorFiles()
{
	if(_kor_font)
		InitXddFont(1,"koreanb.fnt","engb.fnt");
	else
		InitXddFont(0,"koreans.fnt","engs.fnt");

	strcpy(Kostr,gameFN);
	LoadKorString(Kostr);

	if(_kor_mode) fprintf(stderr,"use Korean subtitles\n");
	if(_kor_font) fprintf(stderr,"use large font for Korean\n");
	if(_not_eng)  fprintf(stderr,"no English subtitles with Korean subtitles\n");

	if(korOutput=fopen(gameFN,"r")) {
		int k;
		char buf0[256];
		char *pt;
		pt=buf0;

		for(k=0;!feof(korOutput);k++) {
			fgets(pt,256,korOutput);
		}fclose(korOutput);
	
		xxi=k;

		korOutput=fopen(gameFN,"rt");

		for(k=0;k<xxi;k++) {
			fgets(pt,256,korOutput);
			if(strlen(pt)){
				strcpy(strBuf[k],pt);
				strBuf[k][strlen(strBuf[k])-1]=0;
			}
		}
		fclose(korOutput);
	
	}
	korOutput=fopen(gameFN,"at");

}

char *TransDescKor(char *buf) // ΰ(?) ٸ  ѱ۷ ħ.
{
	int Fin;
	char *tbuf,*sbuf;
	sbuf=tbuf=k_parse_buffer;
	static int CurrKor;

	if(buf[0]==0x07)
		*buf++;

	Fin=0;
	for(int i=CurrKor;i<korMax;i+=2){
		if( !strncasecmp(buf,korBuffer[i].data,strlen(korBuffer[i].data)) && strlen(korBuffer[i].data)==strlen(buf) ) {
			strcpy(tbuf,korBuffer[i+1].data);
			CurrKor=i;
			Fin=1;
			break;
		}
	}
	if(Fin==0){
		for(i=0;i<CurrKor;i+=2){ //ѹ  ã 
			if( !strncasecmp(buf,korBuffer[i].data,strlen(korBuffer[i].data)) && strlen(korBuffer[i].data)==strlen(buf) ) {
				strcpy(tbuf,korBuffer[i+1].data);
				CurrKor=i;
				Fin=1;
				break;
			}
		}
	}
	if(Fin==0)
		if(isCMI) strcpy(tbuf,buf);
		else *tbuf=0;
	return tbuf;
}

char *Convert2Korean(char *buf) //20030110: ġ ޸ ħ ׸ ħ.
{
	int Fin;
	char *tbuf,*sbuf;
	sbuf=tbuf=k_parse_buffer;
	static CurrKor;

		bool mFlg;
		mFlg=0;
		for(int mi=0;mi<xxi;mi++) {
			if(!strncasecmp(buf,strBuf[mi],strlen(buf))){
				mFlg=1;
				break;
			}
		}
		if(!mFlg) {
			strcpy(strBuf[xxi],buf);
			xxi++;
			fprintf(korOutput,"%s\n",buf);
		} //ӽ Ͽ 

	Fin=0;
	//memset(tbuf,0,1023);
	for(int i=CurrKor;i<korMax;i+=2){
		if( !strncasecmp(buf,korBuffer[i].data,strlen(korBuffer[i].data)) && strlen(korBuffer[i].data)==strlen(buf) ) {
			strcpy(tbuf,korBuffer[i+1].data);
			CurrKor=i;
			Fin=1;
			break;
		}
	}
	if(Fin==0){
		for(i=0;i<CurrKor;i+=2){ //ѹ  ã 
			if( !strncasecmp(buf,korBuffer[i].data,strlen(korBuffer[i].data)) && strlen(korBuffer[i].data)==strlen(buf) ) {
				strcpy(tbuf,korBuffer[i+1].data);
				CurrKor=i;
				Fin=1;
				break;
			}
		}
	}
	if(Fin==0)
		if(_not_eng) {
			strcpy(tbuf,buf); // ã,   ü...;;
			while(*tbuf){
				if(!strncasecmp(tbuf,"<1>",strlen("<1>"))) {
					*tbuf='\\';
					*(tbuf+1)='\\';
					*(tbuf+2)='n';
				}
				if(!strncasecmp(buf,"<3>",strlen("<3>"))) {
					*tbuf='\\';
					*(tbuf+1)='\\';
					*(tbuf+2)='n';
				}
				if(!strncasecmp(tbuf,"<c>",strlen("<c>"))) {
					*tbuf='\\';
					*(tbuf+1)='\\';
					*(tbuf+2)='c';
					// *(buf+3)=' ';
				}
				tbuf++;
			}
			tbuf=sbuf;
		} else *tbuf=0; // ȳö ü.
	return tbuf;
}

//////////////////////
//ѱ 
//////////////////////
Uint16 RGB2(SDL_Surface *screen, Uint8 R, Uint8 G, Uint8 B)
{
    return SDL_MapRGB(screen->format, R, G, B);
}

void Put_Eng16(Uint16 *v,int nWidth,Uint16 color,char *pData)
{
	char  *p = pPattern;
	int w;
	if(_kor_font) w=16; else w=8;
	for(int i=0;i<w;i++)
	{
		color += *p++;
		if(*pData)
		{
			if(*pData & 0X80) *(v)   = color;
			if(*pData & 0X40) *(v+1) = color;
			if(*pData & 0X20) *(v+2) = color;
			if(*pData & 0X10) *(v+3) = color;
			if(*pData & 0X08) *(v+4) = color;
			if(*pData & 0X04) *(v+5) = color;
			if(*pData & 0X02) *(v+6) = color;
			if(*pData & 0X01) *(v+7) = color;
		}
		v += nWidth;
		pData++;
	}
}

void Put_Han16(Uint16 *v,int nWidth,Uint16 color,char *pData)
{
	char  *p = pPattern;
	int w;
	if(_kor_font) w=15; else w=9;
	for(int i=0;i<w;i++)
	{
		color += *p++;
		if(*pData)
		{
			if (*pData & 0X80) *(v  )=color;
			if (*pData & 0X40) *(v+1)=color;
			if (*pData & 0X20) *(v+2)=color;
			if (*pData & 0X10) *(v+3)=color;
			if (*pData & 0X08) *(v+4)=color;
			if (*pData & 0X04) *(v+5)=color;
			if (*pData & 0X02) *(v+6)=color;
			if (*pData & 0X01) *(v+7)=color;
		}
		pData++;
		if(*pData)
		{
			if (*pData & 0X80) *(v+ 8)=color;
			if (*pData & 0X40) *(v+ 9)=color;
			if (*pData & 0X20) *(v+10)=color;
			if (*pData & 0X10) *(v+11)=color;
			if (*pData & 0X08) *(v+12)=color;
			if (*pData & 0X04) *(v+13)=color;
			if (*pData & 0X02) *(v+14)=color;
			if (*pData & 0X01) *(v+15)=color;
		}
		v += nWidth;
		pData++;
	}
}

int GetKsIndex(Uint8 fstByte,Uint8 sndByte)
{
	/*if(sndByte==32)
		sndByte=0xFA;*/
	if(sndByte<=36) //̷ ص ǳ...? ߻ϴ  sndByte = 32 ε...
		sndByte+=218;
	return ( (int)fstByte  - 0xb0) * 94 + (int)sndByte - 0xa1;
}
#define getmg(cheb,ewid) case cheb: return ewid; break
int TopMG(Uint8 eb)
{
	if(_kor_font)
		return 0;
	else

		switch(eb) {

			getmg('g',1);
			getmg('p',1);
			getmg('q',1);
			getmg('y',1);
			getmg(',',1);
			getmg('!',1);
			//getmg('.',1);

		default:
			return 0;
			break;
		}

}

#define width(cheb,ewid) case cheb: return ewid; break
int GetEW(Uint8 eb)
{
	if(_kor_font)
		return ENGLISH_WIDTH;
	else

	switch(eb) {

		width(' ',4);
		width('5',8);
		width('_',9);
		width('I',6);
		width('J',8);
		width('M',8);
		width('W',8);
		width('c',6);
		width('e',7);
		width('f',6);
		width('i',6);
		width('l',6);
		width('m',8);
		width('w',8);
		width('.',5);
		width('*',8);
		width('!',5);
	default:
		return 7;
		break;
	}
}
#define HERE(n) printf(" %d\n",n);
int PutFont(SDL_Surface *screen, int xPos, int yPos, int w, int h,
			Uint16 color,char *pStr,short ClipWidth )//16bit 
{
	int px;
	Uint8 fstByte, secByte;
	Uint16 *ptr;
	px = xPos;
    if ( SDL_MUSTLOCK(screen) ) {
        if ( SDL_LockSurface(screen) < 0 ) {
			printf("PutFont() : Lock \n");
            return xPos;
        }
    }
	ptr = (Uint16 *)screen->pixels + yPos * screen->pitch / 2 + xPos;
	while(*pStr){
		fstByte = *pStr++;
		if ( (fstByte & 0x80) /*&& !(fstByte==0xfa)*/ ) {  // ѱ
			if ( xPos >= 0 && xPos <= (w - (HANGUL_WIDTH+(1 - ClipWidth))) ) {
		if(yPos<(isCMI ? 480 : 200)-kFontHeight) {
					ptr =(Uint16 *)screen->pixels + yPos * screen->pitch / 2 + xPos;
					if (_kor_font)	Put_Han16(ptr,(screen->pitch / 2),color,HANKSB[GetKsIndex(fstByte,*pStr)]);
									Put_Han16(ptr,(screen->pitch / 2),color,HANKSS[GetKsIndex(fstByte,*pStr)]);
				}
			} else {
				if(xPos > (w - (HANGUL_WIDTH+(1-ClipWidth)))) {
					xPos = px;
					yPos+=kFontHeight+2;
					if(yPos<(isCMI ? 480 : 200)-kFontHeight) {
						ptr = (Uint16 *)screen->pixels + yPos * screen->pitch / 2 + xPos;
						if (_kor_font)	Put_Han16(ptr,(screen->pitch / 2),color,HANKSB[GetKsIndex(fstByte,*pStr)]);
						else			Put_Han16(ptr,(screen->pitch / 2),color,HANKSS[GetKsIndex(fstByte,*pStr)]);
					}
				}
			}
			ptr += HANGUL_WIDTH;
			pStr++;
			xPos += HANGUL_WIDTH;

		} else {
			if ( (fstByte != ' ' /*&& fstByte !=0xfa*/) ) {// 
				if ( fstByte == '\\' )	{
					secByte = *pStr++;

					if ( secByte == 'n' || secByte == 'N' )	{
						xPos  = px;
						yPos+=kFontHeight+2;
						ptr = (Uint16 *)screen->pixels + (yPos) * screen->pitch / 2 + xPos;
					} else if ( secByte == 'c' || secByte == 'C' )	{
						uint8 d=*pStr++;
						if (color) //  (0,0,0) ƴ϶
							color = RGB_TO_16(kpalette[d].r, kpalette[d].g, kpalette[d].b);
					} else pStr--;

				} else if ( fstByte == 0x0d ) {
					secByte = *pStr++;

					if ( secByte == 0x0a )	{
						xPos  = px;
						yPos+=kFontHeight+2;
						ptr = (Uint16 *)screen->pixels + (yPos) * screen->pitch / 2 + xPos;
					} else pStr--;

				} else {

				        if ( xPos >= 0 && xPos <= (w - (ENGLISH_WIDTH+(1-ClipWidth))) )	{
							if(yPos<(isCMI ? 480 : 200)-kFontHeight) {
								ptr = (Uint16 *)screen->pixels + (yPos+1+TopMG(fstByte)) * screen->pitch / 2 + xPos;
								if(_kor_font)	Put_Eng16(ptr,(screen->pitch / 2),color,*(EFB+fstByte));
								else			Put_Eng16(ptr,(screen->pitch / 2),color,*(EFS+fstByte));
							}
						} else {
							if(xPos>(w - (ENGLISH_WIDTH+(1-ClipWidth)))) {
								xPos = px;
								yPos+=kFontHeight;
								if(yPos<(isCMI ? 480 : 200)-kFontHeight) {
									ptr = (Uint16 *)screen->pixels + (yPos+1+TopMG(fstByte)) * screen->pitch / 2 + xPos;
									if(_kor_font)	Put_Eng16(ptr,(screen->pitch / 2),color,*(EFB+fstByte));
									else			Put_Eng16(ptr,(screen->pitch / 2),color,*(EFS+fstByte));
								}
							}
						}
						ptr += GetEW(fstByte);

					xPos += GetEW(fstByte);
				}
			} else {
				ptr += GetEW(' ');
				xPos += GetEW(' ');
			}
		}
	}
	if ( SDL_MUSTLOCK(screen) )
        SDL_UnlockSurface(screen);
	return xPos;
}

int PutFontOutline( SDL_Surface *screen, int xPos,int yPos, int w, int h, uint16 color,char *fmt,... )
{
	char buffer[256], str[256];

	va_list argptr;
	va_start(argptr, fmt);
	vsprintf(buffer,fmt,argptr);
	va_end(argptr);

	if(!isCMI) strcpy( str, buffer );
	if(!isCMI) PutFont(screen,xPos,yPos-1,w,h,0,str,0);
	if(!isCMI) strcpy( str, buffer );
	if(!isCMI) PutFont(screen,xPos,yPos+1,w,h,0,str,0);
	strcpy( str, buffer );
	PutFont(screen,xPos-1,yPos,w,h,0,str,-1);
	strcpy( str, buffer );
	PutFont(screen,xPos+1,yPos,w,h,0,str,+1);
	
	if(!isCMI) strcpy( str, buffer );
	if(!isCMI) PutFont(screen,xPos-1,yPos-1,w,h,0,str,-1);
	if(!isCMI) strcpy( str, buffer );
	if(!isCMI) PutFont(screen,xPos+1,yPos+1,w,h,0,str,+1);
	if(!isCMI) strcpy( str, buffer );
	if(!isCMI) PutFont(screen,xPos-1,yPos+1,w,h,0,str,-1);
	if(!isCMI) strcpy( str, buffer );
	if(!isCMI) PutFont(screen,xPos+1,yPos-1,w,h,0,str,+1);

	return PutFont(screen,xPos,yPos,w,h,color,buffer,0);
}

bool LoadFont(bool size,char *pFile,Uint16 wType)
{
	FILE *fp;
	fp = fopen(pFile,"rb");
	if(fp==NULL) return false;

	if(wType == ENGLISH_FNT)
	{
		if(size) fread(EFB, 4096, 1, fp);
		else fread(EFS, 2048, 1, fp);
	} else
	{
		if(size) fread(HANKSB,70500, 1, fp);
		else fread(HANKSS,42300, 1, fp);
	}

	fclose(fp);
	return true;
}

void SetFontWidth(int nHangul,int nEnglish,int nSpace)
{
	HANGUL_WIDTH  = nHangul;
	ENGLISH_WIDTH = nEnglish;
	SPACE_WIDTH   = nSpace;
}

bool InitXddFont(bool size, char *pHan,char *pEng)
{
	bool ret = false;

	pPattern = &pattNormal[0];
	if(pHan)
	{
		ret = LoadFont(size,pHan,HANGUL_FNT);
		if(!ret){ fprintf(stderr,"Couldn't load Korean font!\n");return false;}
		if(size) {
			SetFontWidth(16,ENGLISH_WIDTH,8);
			kFontHeight=16;
		} else {
			SetFontWidth(10,ENGLISH_WIDTH,8);
			kFontHeight=10;
		}
	}

	if(pEng)
	{
		ret = LoadFont(size,pEng,ENGLISH_FNT);
			SetFontWidth(HANGUL_WIDTH,8,8);
			eFontHeight=8;
	}
	fprintf(stderr,"Korean font loaded!\n");
	return ret;
}
bool DeleteKorString()
{
	for(int k=0;k<korMax;k++)
		free(korBuffer[k].data);
	delete []korBuffer;
	return true;
}
bool LoadKorString(char *gn)
{
	FILE *fp;
	char fname[256];

	if(!strncasecmp(gn,"monkeyega",9))
		strcpy(gn,"monkey");
	if(!strncasecmp(gn,"monkeyvga",9))
		strcpy(gn,"monkey");
	if(!strncasecmp(gn,"monkey1",7))
		strcpy(gn,"monkey");
	if(!strncasecmp(gn,"indy3ega",8))
		strcpy(gn,"indy3");

	sprintf(fname,"kor_%s.dat",gn);
	fp=fopen(fname,"rt");
	if(fp==NULL) {
		fprintf(stderr,"Couldn't load Korean string table!\n");
	return false;
	}

	int k;
	char buf[1024];
	char *ptr;
	ptr=buf;

	for(k=0;!feof(fp);k++) {
		fgets(ptr,256,fp);
	}fclose(fp);

	korBuffer=new STRKORBUFFER[k];
	korMax=k;

	fp=fopen(fname,"rt");
	for(k=0;k<korMax;k++) {
		fgets(ptr,256,fp);
		korBuffer[k].data=new char[(strlen(ptr)+1)];
		if(strlen(ptr)) {
			if(*(ptr+1)=='%') {
				*ptr++;
				korBuffer[k].attr=1;
			}
			strcpy(korBuffer[k].data,ptr);
			if(korBuffer[k].data[strlen(korBuffer[k].data)-1] == '\n' ||
				korBuffer[k].data[strlen(korBuffer[k].data)-1] == 0x0a ||
				korBuffer[k].data[strlen(korBuffer[k].data)-1] == 0x0d)
				korBuffer[k].data[strlen(korBuffer[k].data)-1]=0;
		}
		korBuffer[k].data[strlen(korBuffer[k].data)-1]=0;
	}
	fclose(fp);

	fprintf(stdout,"Korean string table loaded! -- Total %d lines\n",korMax);

	return true;
}
////////////////////////////////////////////////////////////////////////////////
